JTS Topology Suite version 1.13

## com.vividsolutions.jts.geom
Class LineString

    java.lang.Object
      com.vividsolutions.jts.geom.Geometry
          com.vividsolutions.jts.geom.LineString

All Implemented Interfaces:
  Lineal, java.io.Serializable, java.lang.Cloneable, java.lang.Comparable

Direct Known Subclasses:
  LinearRing

    public class LineString

extends Geometry
implements Lineal

Models an OGC-style `LineString`. A LineString consists of a sequence of two or more vertices, along with all points along the linearly-interpolated curves (line segments) between each pair of consecutive vertices. Consecutive vertices may be equal. The line segments in the line may intersect each other (in other words, the linestring may "curl back" in itself and self-intersect. Linestrings with exactly two identical points are invalid.

A linestring must have either 0 or 2 or more points. If these conditions are not met, the constructors throw an `IllegalArgumentException`

Version:
  1.7
See Also:
  Serialized Form

Field Summary
`protected CoordinateSequence` `points` The points of this `LineString`.

Fields inherited from class com.vividsolutions.jts.geom.Geometry
`envelope, factory, SRID`

Constructor Summary
`LineString(Coordinate[] points, PrecisionModel precisionModel, int SRID)` Deprecated. Use GeometryFactory instead
`LineString(CoordinateSequence points, GeometryFactory factory)` Constructs a `LineString` with the given points.

Method Summary
`void` `apply(CoordinateFilter filter)` Performs an operation with or on this `Geometry`'s coordinates.
`void` `apply(CoordinateSequenceFilter filter)` Performs an operation on the coordinates in this `Geometry`'s `CoordinateSequence`s.
`void` `apply(GeometryComponentFilter filter)` Performs an operation with or on this Geometry and its component Geometry's.
`void` `apply(GeometryFilter filter)` Performs an operation with or on this `Geometry` and its subelement `Geometry`s (if any).
`java.lang.Object` `clone()` Creates and returns a full copy of this `LineString` object.
`protected int` `compareToSameClass(java.lang.Object o)` Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` having the same class.
`protected int` `compareToSameClass(java.lang.Object o, CoordinateSequenceComparator comp)` Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` of the same class.
`protected Envelope` `computeEnvelopeInternal()` Returns the minimum and maximum x and y values in this `Geometry` , or a null `Envelope` if this `Geometry` is empty.
`boolean` `equalsExact(Geometry other, double tolerance)` Returns true if the two `Geometry`s are exactly equal, up to a specified distance tolerance.
`Geometry` `getBoundary()` Gets the boundary of this geometry.
`int` `getBoundaryDimension()` Returns the dimension of this `Geometry`s inherent boundary.
`Coordinate` `getCoordinate()` Returns a vertex of this `Geometry` (usually, but not necessarily, the first one).
`Coordinate` `getCoordinateN(int n)`
`Coordinate[]` `getCoordinates()` Returns an array containing the values of all the vertices for this geometry.
`CoordinateSequence` `getCoordinateSequence()`
`int` `getDimension()` Returns the dimension of this geometry.
`Point` `getEndPoint()`
`java.lang.String` `getGeometryType()` Returns the name of this Geometry's actual class.
`double` `getLength()` Returns the length of this `LineString`
`int` `getNumPoints()` Returns the count of this `Geometry`s vertices.
`Point` `getPointN(int n)`
`Point` `getStartPoint()`
`boolean` `isClosed()`
`boolean` `isCoordinate(Coordinate pt)` Returns true if the given point is a vertex of this `LineString`.
`boolean` `isEmpty()` Tests whether the set of points covered by this `Geometry` is empty.
`protected boolean` `isEquivalentClass(Geometry other)` Returns whether the two `Geometry`s are equal, from the point of view of the `equalsExact` method.
`boolean` `isRing()`
`void` `normalize()` Normalizes a LineString.
`Geometry` `reverse()` Creates a `LineString` whose coordinates are in the reverse order of this objects

Methods inherited from class com.vividsolutions.jts.geom.Geometry

`buffer, buffer, buffer, checkNotGeometryCollection, compare, compareTo, compareTo, contains, convexHull, coveredBy, covers, crosses, difference, disjoint, distance, equal, equals, equals, equalsExact, equalsNorm, equalsTopo, geometryChanged, geometryChangedAction, getArea, getCentroid, getEnvelope, getEnvelopeInternal, getFactory, getGeometryN, getInteriorPoint, getNumGeometries, getPrecisionModel, getSRID, getUserData, hashCode, hasNonEmptyElements, hasNullElements, intersection, intersects, isGeometryCollection, isRectangle, isSimple, isValid, isWithinDistance, norm, overlaps, relate, relate, setSRID, setUserData, symDifference, toString, toText, touches, union, union, within`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### points

    protected CoordinateSequence points

  The points of this `LineString`.

Constructor Detail

### LineString

    public LineString(Coordinate[] points,
                      PrecisionModel precisionModel,
                      int SRID)

  Deprecated. Use GeometryFactory instead

### LineString

    public LineString(CoordinateSequence points,
                      GeometryFactory factory)

  Constructs a `LineString` with the given points.

  Parameters:
    `points` - the points of the linestring, or `null` to create the empty geometry. Consecutive points may not be equal.
  Throws:
    `java.lang.IllegalArgumentException` - if too few points are provided

Method Detail

### getCoordinates

    public Coordinate[] getCoordinates()

  Description copied from class: `Geometry`
  Returns an array containing the values of all the vertices for this geometry. If the geometry is a composite, the array will contain all the vertices for the components, in the order in which the components occur in the geometry.

  In general, the array cannot be assumed to be the actual internal storage for the vertices. Thus modifying the array may not modify the geometry itself. Use the `CoordinateSequence.setOrdinate(int, int, double)` method (possibly on the components) to modify the underlying data. If the coordinates are modified, `Geometry.geometryChanged()` must be called afterwards.

  Specified by:
    `getCoordinates` in class `Geometry`
  Returns:
    the vertices of this `Geometry`
  See Also:
    `Geometry.geometryChanged()`, `CoordinateSequence.setOrdinate(int, int, double)`

### getCoordinateSequence

    public CoordinateSequence getCoordinateSequence()

### getCoordinateN

    public Coordinate getCoordinateN(int n)

### getCoordinate

    public Coordinate getCoordinate()

  Description copied from class: `Geometry`
  Returns a vertex of this `Geometry` (usually, but not necessarily, the first one). The returned coordinate should not be assumed to be an actual Coordinate object used in the internal representation.

  Specified by:
    `getCoordinate` in class `Geometry`
  Returns:
    a `Coordinate` which is a vertex of this `Geometry`.

### getDimension

    public int getDimension()

  Description copied from class: `Geometry`
  Returns the dimension of this geometry. The dimension of a geometry is is the topological dimension of its embedding in the 2-D Euclidean plane. In the JTS spatial model, dimension values are in the set {0,1,2}.

  Note that this is a different concept to the dimension of the vertex `Coordinate`s. The geometry dimension can never be greater than the coordinate dimension. For example, a 0-dimensional geometry (e.g. a Point) may have a coordinate dimension of 3 (X,Y,Z).

  Specified by:
    `getDimension` in class `Geometry`
  Returns:
    the topological dimension of this geometry.

### getBoundaryDimension

    public int getBoundaryDimension()

  Description copied from class: `Geometry`
  Returns the dimension of this `Geometry`s inherent boundary.

  Specified by:
    `getBoundaryDimension` in class `Geometry`
  Returns:
    the dimension of the boundary of the class implementing this interface, whether or not this object is the empty geometry. Returns `Dimension.FALSE` if the boundary is the empty geometry.

### isEmpty

    public boolean isEmpty()

  Description copied from class: `Geometry`
  Tests whether the set of points covered by this `Geometry` is empty.

  Specified by:
    `isEmpty` in class `Geometry`
  Returns:
    `true` if this `Geometry` does not cover any points

### getNumPoints

    public int getNumPoints()

  Description copied from class: `Geometry`
  Returns the count of this `Geometry`s vertices. The `Geometry` s contained by composite `Geometry`s must be Geometry's; that is, they must implement `getNumPoints`

  Specified by:
    `getNumPoints` in class `Geometry`
  Returns:
    the number of vertices in this `Geometry`

### getPointN

    public Point getPointN(int n)

### getStartPoint

    public Point getStartPoint()

### getEndPoint

    public Point getEndPoint()

### isClosed

    public boolean isClosed()

### isRing

    public boolean isRing()

### getGeometryType

    public java.lang.String getGeometryType()

  Description copied from class: `Geometry`
  Returns the name of this Geometry's actual class.

  Specified by:
    `getGeometryType` in class `Geometry`
  Returns:
    the name of this `Geometry`s actual class

### getLength

    public double getLength()

  Returns the length of this `LineString`

  Overrides:
    `getLength` in class `Geometry`
  Returns:
    the length of the linestring

### getBoundary

    public Geometry getBoundary()

  Gets the boundary of this geometry. The boundary of a lineal geometry is always a zero-dimensional geometry (which may be empty).

  Specified by:
    `getBoundary` in class `Geometry`
  Returns:
    the boundary geometry
  See Also:
    `Geometry.getBoundary()`

### reverse

    public Geometry reverse()

  Creates a `LineString` whose coordinates are in the reverse order of this objects

  Specified by:
    `reverse` in class `Geometry`
  Returns:
    a `LineString` with coordinates in the reverse order

### isCoordinate

    public boolean isCoordinate(Coordinate pt)

  Returns true if the given point is a vertex of this `LineString`.

  Parameters:
    `pt` - the `Coordinate` to check
  Returns:
    `true` if `pt` is one of this `LineString` 's vertices

### computeEnvelopeInternal

    protected Envelope computeEnvelopeInternal()

  Description copied from class: `Geometry`
  Returns the minimum and maximum x and y values in this `Geometry` , or a null `Envelope` if this `Geometry` is empty. Unlike `getEnvelopeInternal`, this method calculates the `Envelope` each time it is called; `getEnvelopeInternal` caches the result of this method.

  Specified by:
    `computeEnvelopeInternal` in class `Geometry`
  Returns:
    this `Geometry`s bounding box; if the `Geometry` is empty, `Envelope#isNull` will return `true`

### equalsExact

    public boolean equalsExact(Geometry other,
                               double tolerance)

  Description copied from class: `Geometry`
  Returns true if the two `Geometry`s are exactly equal, up to a specified distance tolerance. Two Geometries are exactly equal within a distance tolerance if and only if:
  - they have the same structure
  - they have the same values for their vertices, within the given tolerance distance, in exactly the same order.
  This method does not test the values of the `GeometryFactory`, the `SRID`, or the `userData` fields.

  To properly test equality between different geometries, it is usually necessary to `Geometry.normalize()` them first.

  Specified by:
    `equalsExact` in class `Geometry`
  Parameters:
    `other` - the `Geometry` with which to compare this `Geometry`
    `tolerance` - distance at or below which two `Coordinate`s are considered equal
  Returns:
    `true` if this and the other `Geometry` have identical structure and point values, up to the distance tolerance.
  See Also:
    `Geometry.equalsExact(Geometry)`, `Geometry.normalize()`, `Geometry.norm()`

### apply

    public void apply(CoordinateFilter filter)

  Description copied from class: `Geometry`
  Performs an operation with or on this `Geometry`'s coordinates. If this method modifies any coordinate values, `Geometry.geometryChanged()` must be called to update the geometry state. Note that you cannot use this method to modify this Geometry if its underlying CoordinateSequence's #get method returns a copy of the Coordinate, rather than the actual Coordinate stored (if it even stores Coordinate objects at all).

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply to this `Geometry`'s coordinates

### apply

    public void apply(CoordinateSequenceFilter filter)

  Description copied from class: `Geometry`
  Performs an operation on the coordinates in this `Geometry`'s `CoordinateSequence`s. If the filter reports that a coordinate value has been changed, `Geometry.geometryChanged()` will be called automatically.

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply

### apply

    public void apply(GeometryFilter filter)

  Description copied from class: `Geometry`
  Performs an operation with or on this `Geometry` and its subelement `Geometry`s (if any). Only GeometryCollections and subclasses have subelement Geometry's.

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply to this `Geometry` (and its children, if it is a `GeometryCollection`).

### apply

    public void apply(GeometryComponentFilter filter)

  Description copied from class: `Geometry`
  Performs an operation with or on this Geometry and its component Geometry's. Only GeometryCollections and Polygons have component Geometry's; for Polygons they are the LinearRings of the shell and holes.

  Specified by:
    `apply` in class `Geometry`
  Parameters:
    `filter` - the filter to apply to this `Geometry`.

### clone

    public java.lang.Object clone()

  Creates and returns a full copy of this `LineString` object. (including all coordinates contained by it).

  Overrides:
    `clone` in class `Geometry`
  Returns:
    a clone of this instance

### normalize

    public void normalize()

  Normalizes a LineString. A normalized linestring has the first point which is not equal to it's reflected point less than the reflected point.

  Specified by:
    `normalize` in class `Geometry`

### isEquivalentClass

    protected boolean isEquivalentClass(Geometry other)

  Description copied from class: `Geometry`
  Returns whether the two `Geometry`s are equal, from the point of view of the `equalsExact` method. Called by `equalsExact` . In general, two `Geometry` classes are considered to be "equivalent" only if they are the same class. An exception is `LineString` , which is considered to be equivalent to its subclasses.

  Overrides:
    `isEquivalentClass` in class `Geometry`
  Parameters:
    `other` - the `Geometry` with which to compare this `Geometry` for equality
  Returns:
    `true` if the classes of the two `Geometry` s are considered to be equal by the `equalsExact` method.

### compareToSameClass

    protected int compareToSameClass(java.lang.Object o)

  Description copied from class: `Geometry`
  Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` having the same class.

  Specified by:
    `compareToSameClass` in class `Geometry`
  Parameters:
    `o` - a `Geometry` having the same class as this `Geometry`
  Returns:
    a positive number, 0, or a negative number, depending on whether this object is greater than, equal to, or less than `o`, as defined in "Normal Form For Geometry" in the JTS Technical Specifications

### compareToSameClass

    protected int compareToSameClass(java.lang.Object o,
                                     CoordinateSequenceComparator comp)

  Description copied from class: `Geometry`
  Returns whether this `Geometry` is greater than, equal to, or less than another `Geometry` of the same class. using the given `CoordinateSequenceComparator`.

  Specified by:
    `compareToSameClass` in class `Geometry`
  Parameters:
    `o` - a `Geometry` having the same class as this `Geometry`
    `comp` - a `CoordinateSequenceComparator`
  Returns:
    a positive number, 0, or a negative number, depending on whether this object is greater than, equal to, or less than `o`, as defined in "Normal Form For Geometry" in the JTS Technical Specifications

JTS Topology Suite version 1.13